set (IRRLICHT_FOUND TRUE)

find_path (
    IRRLICHT_INCLUDE_DIRS
    NAMES
        irrlicht.h
    HINTS
        ENV
        IRRLICHT_ROOT
    PATHS
        /usr
        /usr/local
    PATH_SUFFIXES
        include
        irrlicht
)

find_library (
    IRRLICHT_LIBRARY
        Irrlicht
    HINTS
        ENV
        IRRLICHT_ROOT
    PATHS
        /usr/lib
        /usr/local/lib
)

if (IRRLICHT_INCLUDE_DIRS AND EXISTS "${IRRLICHT_INCLUDE_DIRS}/IrrCompileConfig.h")
    file (STRINGS "${IRRLICHT_INCLUDE_DIRS}/IrrCompileConfig.h"
          verstr REGEX "^#define[ \t]+IRRLICHT_SDK_VERSION[ \t]+\".+\""
    )
    string (REGEX REPLACE "^#define[ \t]+IRRLICHT_SDK_VERSION[ \t]+\"([^\"]+)\".*" "\\1"
            IRRLICHT_VERSION_STRING "${verstr}"
    )
    unset (verstr)
endif ()

include (FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS (Irrlicht REQUIRED_VARS IRRLICHT_LIBRARY IRRLICHT_INCLUDE_DIRS VERSION_VAR IRRLICHT_VERSION_STRING)

mark_as_advanced (IRRLICHT_INCLUDE_DIRS IRRLICHT_LIBRARIES)
