#include <QFile>
#include <QString>
#include <QTextStream>

QTextStream out(stdout);
QTextStream err(stderr);

int main(int argc, char **argv)
{
    if (argc == 2)
    {
        QFile file(argv[1]);

        if (!file.exists())
        {
            err << "ERROR: unable to open file '" << file.fileName() << "'" << endl;
            return 1;
        }

        if (file.open(QIODevice::ReadOnly))
        {
            QByteArray stream(file.size(), '\0');

            file.read(stream.data(), file.size());
            file.close();

            if (stream[0] == 'x')
            {
                err << "ERROR: file '" << file.fileName() << "' is zlib compressed already" << endl;
                return 1;
            }

            stream = qCompress(stream, 9).mid(sizeof (quint32));

            file.setFileName(file.fileName() + ".z");
            if (file.open(QIODevice::WriteOnly))
            {
                file.write(stream);
                file.close();

                return 0;
            }
            else
            {
                err << "ERROR: file '" << file.fileName() << "' is not writeable" << endl;
                return 1;
            }
        }
        else
        {
            err << "ERROR: file '" << file.fileName() << "' is not readable" << endl;
            return 1;
        }
    }

    out << "usage: " << argv[0] << " <file to compress>" << endl;

    return 0;
}
